/*
 *  Copyright (C) 2009 Jesus Nuevo Chiquero, RobeSafe Research Group
 *
 *  This file is part of FeaturePointMaker
 *
 *  FeaturePointMaker is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FeaturePointMaker is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with touchfreeze; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 *
 *  On Debian GNU/Linux systems, the complete text of the GNU General
 *  Public License can be found in the /usr/share/common-licenses/GPL file.
 */

#include "basic_utils.hh"


void deleteIplImage(IplImage *img)
{

    cvReleaseImage(&img);
// #ifdef DEBUG
//     std::cout << "Liberado IplImage" << std::endl;
// #endif /* DEBUG  */
}


void deleteCvMat(CvMat *mat)
{

    cvReleaseMat(&mat);
// #ifdef DEBUG
//     std::cout << "Liberado IplImage" << std::endl;
// #endif /* DEBUG  */
}

void deleteFileStorage(CvFileStorage *fs)
{
    cvReleaseFileStorage(&fs);
}

void deleteVideoWriter(CvVideoWriter *vw)
{
    cvReleaseVideoWriter(&vw);
}

void deleteCvKalman(CvKalman * kalman)
{
    cvReleaseKalman(&kalman);

}

void print_arr(const CvArr *arr, bool transpose)
{

    CvMat *mat, head;
    mat = cvGetMat(arr, &head);
  
    if(!transpose){
	for(int ai=0; ai<mat->rows; ai++){
	    for(int bi=0; bi<mat->cols; bi++){
		std::cout << cvGetReal2D(mat, ai, bi) << " ";
	    }
	    std::cout << std::endl;
	}
    }
    else{
	for(int bi=0; bi<mat->cols; bi++){
	    for(int ai=0; ai<mat->rows; ai++){
		std::cout << cvGetReal2D(mat, ai, bi) << " ";
	    }
	    std::cout << std::endl;
	}

    }

}

bool is_box_in_image(const CvRect r, const IplImage *img)
{

    CvRect a = cvRect(0,0, img->width, img->height);
    CvRect t;
    
    t = cvMaxRect(&r, &a);
    
    if(t.x <0 || t.y<0 || t.width != a.width || t.height != a.height)
	return false;

    return true;
}
